/*
    Парус 8 - Панели мониторинга
    Типовые стили
*/

//---------------------
//Подключение библиотек
//---------------------

import { STATE } from "./app.text"; //Текстовые ресурсы и константы
import { red, green, orange, grey } from "@mui/material/colors";

//----------------
//Интерфейс модуля
//----------------

//Цвета
export const APP_COLORS = {
    [STATE.UNDEFINED]: {
        color: "#dcdcdca0",
        contrColor: "black"
    },
    [STATE.INFO]: {
        color: "white",
        contrColor: "black"
    },
    [STATE.OK]: {
        color: green[200],
        contrColor: green[900]
    },
    [STATE.ERR]: {
        color: red[200],
        contrColor: red[900]
    },
    [STATE.WARN]: {
        color: orange[200],
        contrColor: orange[900]
    },
    HOVER: {
        color: grey[200],
        contrColor: grey[900]
    },
    ACTIVE: {
        color: grey[400],
        contrColor: grey[900]
    }
};

//Стили
export const APP_STYLES = {
    SCROLL: {
        "&::-webkit-scrollbar": {
            height: "8px",
            width: "8px"
        },
        "&::-webkit-scrollbar-track": {
            borderRadius: "8px",
            backgroundColor: "#EBEBEB"
        },
        "&::-webkit-scrollbar-thumb": {
            borderRadius: "8px",
            backgroundColor: "#b4b4b4"
        },
        "&::-webkit-scrollbar-thumb:hover": {
            backgroundColor: "#808080"
        }
    }
};
