/*
    Парус 8 - Панели мониторинга - Редактор панелей
    Компоненты: Описание    
*/

//---------
//Константы
//---------

const COMPONETNS = [
    {
        name: "Форма",
        path: "form",
        settings: {
            title: "Параметры формирования",
            autoApply: true,
            items: [
                {
                    name: "AGENT",
                    caption: "Контрагент",
                    unitCode2: "AGNLIST",
                    unitName: "Контрагенты",
                    showMethod: "main",
                    showMethodName: "main",
                    parameter: "Мнемокод",
                    inputParameter: "in_AGNABBR",
                    outputParameter: "out_AGNABBR"
                },
                {
                    name: "DOC_TYPE",
                    caption: "Тип документа",
                    unitCode2: "DOCTYPES",
                    unitName: "Типы документов",
                    showMethod: "main",
                    showMethodName: "main",
                    parameter: "Мнемокод",
                    inputParameter: "in_DOCCODE",
                    outputParameter: "out_DOCCODE"
                }
            ]
        }
    },
    {
        name: "График",
        path: "chart",
        settings2: {
            dataSource: {
                type: "USER_PROC",
                userProc: "ГрафТоп5ДогКонтрТип",
                stored: "UDO_P_P8P_AGNCONTR_CHART",
                respArg: "COUT",
                arguments: [
                    { name: "SAGENT", caption: "Контрагент", dataType: "STR", req: false, value: "", valueSource: "AGENT" },
                    { name: "SDOC_TYPE", caption: "Тип документа", dataType: "STR", req: false, value: "", valueSource: "DOC_TYPE" }
                ]
            }
        }
    },
    {
        name: "Таблица",
        path: "table",
        settings2: {
            dataSource: {
                type: "USER_PROC",
                userProc: "ТаблицаДогКонтрТип",
                stored: "UDO_P_P8P_AGNCONTR_TABLE",
                respArg: "COUT",
                arguments: [
                    { name: "SAGENT", caption: "Контрагент", dataType: "STR", req: false, value: "", valueSource: "AGENT" },
                    { name: "SDOC_TYPE", caption: "Тип документа", dataType: "STR", req: false, value: "", valueSource: "DOC_TYPE" }
                ]
            }
        }
    },
    {
        name: "Индикатор",
        path: "indicator",
        settings: {
            dataSource: {
                type: "USER_PROC",
                userProc: "ИндКолДогКонтрТип",
                stored: "UDO_P_P8P_AGNCONTR_IND",
                respArg: "COUT",
                arguments: [
                    { name: "SAGENT", caption: "Контрагент", dataType: "STR", req: false, value: "", valueSource: "AGENT" },
                    { name: "SDOC_TYPE", caption: "Тип документа", dataType: "STR", req: false, value: "", valueSource: "DOC_TYPE" },
                    {
                        name: "NIND_TYPE",
                        caption: "Тип индикатора (0 - все, 1 - неутвержденные)",
                        dataType: "NUMB",
                        req: true,
                        value: "0",
                        valueSource: ""
                    }
                ]
            }
        }
    },
    {
        name: "Индикатор2",
        path: "indicator",
        settings: {
            dataSource: {
                type: "USER_PROC",
                userProc: "ИндКолДогКонтрТип",
                stored: "UDO_P_P8P_AGNCONTR_IND",
                respArg: "COUT",
                arguments: [
                    { name: "SAGENT", caption: "Контрагент", dataType: "STR", req: false, value: "", valueSource: "AGENT" },
                    { name: "SDOC_TYPE", caption: "Тип документа", dataType: "STR", req: false, value: "", valueSource: "DOC_TYPE" },
                    {
                        name: "NIND_TYPE",
                        caption: "Тип индикатора (0 - все, 1 - неутвержденные)",
                        dataType: "NUMB",
                        req: true,
                        value: "1",
                        valueSource: ""
                    }
                ]
            }
        }
    }
];

//----------------
//Интерфейс модуля
//----------------

export { COMPONETNS };
