create or replace package PKG_P8PANELS_EDITOR as

  /*     */
  procedure USERPROCS_DESC
  (
    SCODE                   in varchar2, --   
    COUT                    out clob     --   
  );

end PKG_P8PANELS_EDITOR;
/
create or replace package body PKG_P8PANELS_EDITOR as

  /*    */
  procedure USERPROCS_DESC
  (
    SCODE                   in varchar2,     --   
    COUT                    out clob         --   
  )
  is
    SRESP_ARG               PKG_STD.TSTRING; --    
  begin
    /*    */
    for C in (select T.RN       NRN,
                     T.PROCNAME SPROC_NAME,
                     T.PROCTYPE NPROC_TYPE
                from USERPROCS T
               where T.CODE = SCODE)
    loop
      /*         */
      if (C.NPROC_TYPE <> 0) then
        P_EXCEPTION(0,
                    '  "%s"        :    " ".',
                    SCODE);
      end if;
      if (C.SPROC_NAME is null) then
        P_EXCEPTION(0,
                    '  "%s"        :    .',
                    SCODE);
      end if;
      /*   XML */
      PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
      /*   */
      PKG_XFAST.DOWN_NODE(SNAME => 'XDATA');
      /*    */
      PKG_XFAST.DOWN_NODE(SNAME => 'XUSERPROC');
      /*   */
      for P in (select T.PARAMTYPE NTYPE,
                       T.PARAMNAME SNAME,
                       T.NAME SCAPTION,
                       T.DATATYPE NDATA_TYPE,
                       case T.DATATYPE
                         when 0 then
                          'STR'
                         when 1 then
                          'NUMB'
                         when 2 then
                          'DATE'
                         else
                          null
                       end SDATA_TYPE,
                       T.MANDATORY NREQ,
                       T.VISUALIZE NVISUALIZE
                  from USERPROCSPARAMS T
                 where T.PRN = C.NRN
                 order by T.POSITION)
      loop
        /*         */
        if ((P.NTYPE = 0) and (P.SDATA_TYPE is not null)) then
          /*    */
          PKG_XFAST.DOWN_NODE(SNAME => 'arguments');
          /*   */
          PKG_XFAST.ATTR(SNAME => 'name', SVALUE => P.SNAME);
          PKG_XFAST.ATTR(SNAME => 'caption', SVALUE => P.SCAPTION);
          PKG_XFAST.ATTR(SNAME => 'dataType', SVALUE => P.SDATA_TYPE);
          PKG_XFAST.ATTR(SNAME  => 'req',
                         BVALUE => case P.NREQ
                                     when 1 then
                                      true
                                     else
                                      false
                                   end);
          /*    */
          PKG_XFAST.UP();
        end if;
        /*      CLOB */
        if ((P.NVISUALIZE = 1) and (P.NDATA_TYPE = 4)) then
          if (SRESP_ARG is null) then
            SRESP_ARG := P.SNAME;
          else
            /*     -  */
            P_EXCEPTION(0,
                        '  "%s"        :       " "   "  ".',
                        SCODE);
          end if;
        end if;
      end loop;
      /*     */
      PKG_XFAST.DOWN_NODE(SNAME => 'stored');
      PKG_XFAST.ATTR(SNAME => 'name', SVALUE => C.SPROC_NAME);
      PKG_XFAST.ATTR(SNAME => 'respArg', SVALUE => SRESP_ARG);
      PKG_XFAST.UP();
      /*    */
      PKG_XFAST.UP();
      /*    */
      PKG_XFAST.UP();
      /*  */
      COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
      /*   XML */
      PKG_XFAST.EPILOGUE();
    end loop;
    /*     */
    if (COUT is null) then
      P_EXCEPTION(0,
                  '  "%s"  .',
                  COALESCE(SCODE, '< >'));
    end if;
    /*         -       CLOB */
    if (SRESP_ARG is null) then
      P_EXCEPTION(0,
                  '  "%s"        :      " "   "  ".',
                  SCODE);
    end if;
  end USERPROCS_DESC;

end PKG_P8PANELS_EDITOR;
/
