create or replace package PKG_P8PANELS_RRPCONFED as

  /*     */
  procedure RRPCONF_GET_SECTIONS
  (
    NRN_RRPCONF             in number,      -- .     
    NROW_ORDER              in number := 0, --   
    NCOL_ORDER              in number := 0, --   
    COUT                    out clob        --  
  );

  /*     */
  procedure RRPCONFSCTN_INSERT
  (
    NPRN                    in number,   -- .     
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   -- .   
  );
  
  /*     */
  procedure RRPCONFSCTN_UPDATE
  (
    NRN                     in number,   -- .  
    SCODE                   in varchar2, --  
    SNAME                   in varchar2  --  
  );
  
  /*     */
  procedure RRPCONFSCTN_DELETE
  (
    NRN                     in number   -- .  
  );
  
  /*   ,      .   */
  procedure RRPCONFSCTNMRK_GET_CODES
  (
    NRN                     in number,    -- .   
    SRRPCONF                out varchar2, --     
    SRRPCONFSCTN            out varchar2, --  
    SRRPCONFSCTNMRK         out varchar2  --   
  );
  
  /*         */
  procedure RRPCONFSCTNMRK_GET_CODE_NAME
  (
    NRRPCONFSCTN            in number,    -- .  
    NRRPROW                 in number,    -- .  
    NRRPCOLUMN              in number,    -- .  
    SCODE                   out varchar2, --   
    SNAME                   out varchar2  --       
  );
  
  /*         */
  procedure RRPCONFSCTNMRK_GET_NAME
  (
    NRRPCONFSCTNMRK         in number,   -- .  
    SNAME                   out varchar2 --       
  );
  
  /*      */
  procedure RRPCONFSCTNMRK_INSERT
  (
    NPRN                    in number,   -- .  
    SCODE                   in varchar2, --   
    SNAME                   in varchar2, --   
    NRRPROW                 in number,   -- .  
    NRRPCOLUMN              in number,   -- .  
    NRN                     out number   -- .   
  );
  
  /*      */
  procedure RRPCONFSCTNMRK_UPDATE
  (
    NRN                     in number,  -- .               
    SNAME                   in varchar2 --  
  );
  
  /*      */
  procedure RRPCONFSCTNMRK_DELETE
  (        
    NRN                     in number   -- .   
  );
  
end PKG_P8PANELS_RRPCONFED;
/
create or replace package body PKG_P8PANELS_RRPCONFED as

  /*        */
  SPRM_MASK_ACC_DC          constant PKG_STD.TSTRING := '_'; --    " "  " "
  SPRM_MASK_ACC             constant PKG_STD.TSTRING := '';         --    ""
  SPRM_MASK_ACC_WO_ANL      constant PKG_STD.TSTRING := '__'; --    ""   
  SPRM_MASK_DATE_FROM       constant PKG_STD.TSTRING := '_';       --    " "
  SPRM_MASK_DATE_TO         constant PKG_STD.TSTRING := '_';      --    " "
  SPRM_MASK_RRPCONF         constant PKG_STD.TSTRING := '';    --     
  
  /*  -   */
  SUNIT_RRPCONFSCTN         constant PKG_STD.TSTRING := 'RRPConfigSection';     --    
  SUNIT_RRPCONFSCTNMRK      constant PKG_STD.TSTRING := 'RRPConfigSectionMark'; --     
  
  /*  -   */
  SACTION_DELETE            constant PKG_STD.TSTRING := 'DELETE'; -- 
  
  /*     */
  function UTL_UNIT_ACTION_GET_ALLOW
  (
    SUNIT                   in varchar2,     --   (.  SUNIT_*)
    SACTION                 in varchar2,     --  (.  SACTION_*)
    NRN                     in number        -- .  
  ) return                  number           --   (0 - , 1 - )
  is
    NRESULT                 PKG_STD.TNUMBER; --   (0 - , 1 - )
  begin
    /*   */
    case SUNIT
      /*     */
      when SUNIT_RRPCONFSCTN then
        /*    */
        case SACTION
          /*  */
          when SACTION_DELETE then
            /*      / /   -   */
            begin
              select 0
                into NRESULT
                from DUAL
               where exists (select null from RRPDOC_STORAGE_SCTN S where S.RRPCONFSCTN = NRN)
                  or exists (select null from RRPDOCPRM P where P.RRPCONFSCTN = NRN)
                  or exists (select null from RRPCONFSCTN C where C.RRPCONFSCTN = NRN);
            exception
              /*     -   */
              when NO_DATA_FOUND then
                NRESULT := 1;
              /*    -   */
              when others then
                NRESULT := 0;
            end;
          /*   */
          else
            NRESULT := 1;
        end case;
      /*      */
      when SUNIT_RRPCONFSCTNMRK then
        /*    */
        case SACTION
          /*  */
          when SACTION_DELETE then
            /*       -   */
            begin
              select 0
                into NRESULT
                from DUAL
               where exists (select null from RRPDOC_STORAGE_MRK M where M.RRPCONFSCTNMRK = NRN);
            exception
              /*     -   */
              when NO_DATA_FOUND then
                NRESULT := 1;
              /*    -   */
              when others then
                NRESULT := 0;
            end;
        else
          NRESULT := 1;
        end case;
      /*   */
      else
        NRESULT := 1;
    end case;
    /*   */
    return NRESULT;
  end UTL_UNIT_ACTION_GET_ALLOW;

  /*       */
  function UTL_RRPCONFSCTNMRKCN_GET_DESC
  (
    NCOMPANY                in number,                -- .  
    NRRPCONFSCTNMRKCN       in number                 -- .     
  ) return                  varchar2                  --  
  is
    SRESULT                 PKG_STD.TSTRING;          --  
    SCN_DESC                PKG_STD.TSTRING;          --    
    RREC                    RRPCONFSCTNMRKCN%rowtype; --     
    RRRPCONFSCTNMRK         RRPCONFSCTNMRK%rowtype;   --    
  
    /*     .    */
    function UTL_MARK_GET_CODE_BY_CN
    (
      NRRPCONFSCTNMRKCN     in number        -- .   
    ) return                varchar2         --  
    is
      SRESULT               PKG_STD.TSTRING; --  
    begin
      /*    */
      begin
        select M.CODE
          into SRESULT
          from RRPCONFSCTNMRKCN T,
               RRPCONFSCTNMRK   M
         where T.RN = NRRPCONFSCTNMRKCN
           and M.RN = T.PRN;
      exception
        when others then
          SRESULT := null;
      end;
      /*   */
      return SRESULT;
    end UTL_MARK_GET_CODE_BY_CN;
    
    /*     .    */
    function UTL_CONF_GET_CODE_BY_CN
    (
      NRRPCONFSCTNMRKCN     in number        -- .   
    ) return                varchar2         --    
    is
      SRESULT               PKG_STD.TSTRING; --    
    begin
      /*      */
      begin
        select C.CODE
          into SRESULT
          from RRPCONFSCTNMRKCN T,
               RRPCONFSCTNMRK   M,
               RRPCONF          C
         where T.RN = NRRPCONFSCTNMRKCN
           and M.RN = T.PRN
           and C.RN = M.RRPCONF;
      exception
        when others then
          SRESULT := null;
      end;
      /*   */
      return SRESULT;
    end UTL_CONF_GET_CODE_BY_CN;
    
    /*      */
    procedure MAKE_PRMS_BY_MASK
    (
      SPRMS_DESC            in out varchar2,  --   
      NCOMPANY              in number,        -- .  
      NRRPCONFSCTNMRKCN     in number,        -- .   
      SMASK                 in varchar2       --  (.  SPRM_MASK_*)
    )
    is
      SDATE_FROM            PKG_STD.TSTRING;  --   " "
      SDATE_TO              PKG_STD.TSTRING;  --   " "
      DDATE_FROM            PKG_STD.TLDATE;   -- _
      SDATE_FROM_PATTERN    PKG_STD.TSTRING;  -- __
      DDATE_TO              PKG_STD.TLDATE;   -- _
      SDATE_TO_PATTERN      PKG_STD.TSTRING;  -- __
      SACCOUNT_DEBIT        PKG_STD.TSTRING;  -- _
      SANALYTIC_DEBIT1      PKG_STD.TSTRING;  -- 1_
      SANALYTIC_DEBIT2      PKG_STD.TSTRING;  -- 2_
      SANALYTIC_DEBIT3      PKG_STD.TSTRING;  -- 3_
      SANALYTIC_DEBIT4      PKG_STD.TSTRING;  -- 4_
      SANALYTIC_DEBIT5      PKG_STD.TSTRING;  -- 5_
      SACCOUNT_CREDIT       PKG_STD.TSTRING;  -- _
      SANALYTIC_CREDIT1     PKG_STD.TSTRING;  -- 1_
      SANALYTIC_CREDIT2     PKG_STD.TSTRING;  -- 2_
      SANALYTIC_CREDIT3     PKG_STD.TSTRING;  -- 3_
      SANALYTIC_CREDIT4     PKG_STD.TSTRING;  -- 4_
      SANALYTIC_CREDIT5     PKG_STD.TSTRING;  -- 5_
      SACCOUNT              PKG_STD.TSTRING;  -- 
      SANALYTIC1            PKG_STD.TSTRING;  -- 1
      SANALYTIC2            PKG_STD.TSTRING;  -- 2
      SANALYTIC3            PKG_STD.TSTRING;  -- 3
      SANALYTIC4            PKG_STD.TSTRING;  -- 4
      SANALYTIC5            PKG_STD.TSTRING;  -- 5
      SRRPCONF              PKG_STD.TSTRING;  -- 
      NRRPCONF_RD           PKG_STD.TNUMBER;  -- _
      SMARK_CODE            PKG_STD.TSTRING;  -- 
      NMARK_CODE_RD         PKG_STD.TNUMBER;  -- _
      SMARK_ROW_CODE        PKG_STD.TSTRING;  -- _
      SMARK_COL_CODE        PKG_STD.TSTRING;  -- _
    begin
      /*       */
      case SMASK
        /* " "  " " */
        when SPRM_MASK_ACC_DC then
          /*   -   */
          SACCOUNT_DEBIT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                     NPRN     => NRRPCONFSCTNMRKCN,
                                                                     SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_DEBIT_P);
          /*   -   1  */
          SANALYTIC_DEBIT1 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT1_P);
          /*   -   2  */
          SANALYTIC_DEBIT2 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT2_P);
          /*   -   3  */
          SANALYTIC_DEBIT3 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT3_P);
          /*   -   4  */
          SANALYTIC_DEBIT4 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT4_P);
          /*   -   5  */
          SANALYTIC_DEBIT5 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT5_P);
          /*   -   */
          SACCOUNT_CREDIT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                      NPRN     => NRRPCONFSCTNMRKCN,
                                                                      SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_CREDIT_P);
          /*   -   1  */
          SANALYTIC_CREDIT1 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT1_P);
          /*   -   2  */
          SANALYTIC_CREDIT2 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT2_P);
          /*   -   3  */
          SANALYTIC_CREDIT3 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT3_P);
          /*   -   4  */
          SANALYTIC_CREDIT4 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT4_P);
          /*   -   5  */
          SANALYTIC_CREDIT5 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT5_P);
          /*     */
          if ((SACCOUNT_DEBIT is not null) or (SANALYTIC_DEBIT1 is not null) or (SANALYTIC_DEBIT2 is not null) or
             (SANALYTIC_DEBIT3 is not null) or (SANALYTIC_DEBIT4 is not null) or (SANALYTIC_DEBIT5 is not null)) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT_DEBIT || '';
            /*     */
            SPRMS_DESC := SPRMS_DESC || '(' || SANALYTIC_DEBIT1 || ',' || SANALYTIC_DEBIT2 || ',' || SANALYTIC_DEBIT3 || ',' ||
                          SANALYTIC_DEBIT4 || ',' || SANALYTIC_DEBIT5 || '),';
          end if;
          /*     */
          if ((SACCOUNT_CREDIT is not null) or (SANALYTIC_CREDIT1 is not null) or (SANALYTIC_CREDIT2 is not null) or
             (SANALYTIC_CREDIT3 is not null) or (SANALYTIC_CREDIT4 is not null) or (SANALYTIC_CREDIT5 is not null)) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT_CREDIT || ',';
            /*     */
            SPRMS_DESC := SPRMS_DESC || '(' || SANALYTIC_CREDIT1 || ',' || SANALYTIC_CREDIT2 || ',' ||
                          SANALYTIC_CREDIT3 || ',' || SANALYTIC_CREDIT4 || ',' || SANALYTIC_CREDIT5 || '),';
          end if;
        /* "" */
        when SPRM_MASK_ACC then
          /*   -  */
          SACCOUNT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                               NPRN     => NRRPCONFSCTNMRKCN,
                                                               SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_P);
          /*   -   1 */
          SANALYTIC1 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC1_P);
          /*   -   2 */
          SANALYTIC2 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC2_P);
          /*   -   3 */
          SANALYTIC3 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC3_P);
          /*   -   4 */
          SANALYTIC4 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC4_P);
          /*   -   5 */
          SANALYTIC5 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC5_P);
          /*    */
          if ((SACCOUNT is not null) or (SANALYTIC1 is not null) or (SANALYTIC2 is not null) or
             (SANALYTIC3 is not null) or (SANALYTIC4 is not null) or (SANALYTIC5 is not null)) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT || '';
            /*     */
            SPRMS_DESC := SPRMS_DESC || '(' || SANALYTIC1 || ',' || SANALYTIC2 || ',' || SANALYTIC3 || ',' ||
                          SANALYTIC4 || ',' || SANALYTIC5 || '),';
          end if;
        /* ""   */
        when SPRM_MASK_ACC_WO_ANL then
          /*   -  */
          SACCOUNT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                               NPRN     => NRRPCONFSCTNMRKCN,
                                                               SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_P);
          /*     */
          if (SACCOUNT is not null) then
            /*     */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT || ',';
          end if;
        /* " " */
        when SPRM_MASK_DATE_FROM then
          /*   -   */
          DDATE_FROM := PKG_RRPCONFSCTNMRKCN.PARAM_GET_DATE_VALUE(NCOMPANY => NCOMPANY,
                                                                  NPRN     => NRRPCONFSCTNMRKCN,
                                                                  SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_FROM_P);
          /*   -   () */
          SDATE_FROM_PATTERN := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                         NPRN     => NRRPCONFSCTNMRKCN,
                                                                         SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_FROM_PATTERN_P);
          /*  " " */
          SDATE_FROM := COALESCE(TO_CHAR(DDATE_FROM, 'dd.mm.yyyy'), SDATE_FROM_PATTERN);
          /*     */
          if (SDATE_FROM is not null) then
            /*    */
            SPRMS_DESC := SPRMS_DESC || ':' || SDATE_FROM || ',';
          end if;
        /* " " */
        when SPRM_MASK_DATE_TO then
          /*   -   */
          DDATE_TO := PKG_RRPCONFSCTNMRKCN.PARAM_GET_DATE_VALUE(NCOMPANY => NCOMPANY,
                                                                NPRN     => NRRPCONFSCTNMRKCN,
                                                                SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_TO_P);
          /*   -   () */
          SDATE_TO_PATTERN := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_TO_PATTERN_P);
          /*  " " */
          SDATE_TO := COALESCE(TO_CHAR(DDATE_TO, 'dd.mm.yyyy'), SDATE_TO_PATTERN);
          /*     */
          if (SDATE_TO is not null) then
            /*    */
            SPRMS_DESC := SPRMS_DESC || ':' || SDATE_TO || ',';
          end if;
        /*    */
        when SPRM_MASK_RRPCONF then
          /*   -    */
          SRRPCONF := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                               NPRN     => NRRPCONFSCTNMRKCN,
                                                               SPARAM   => PKG_RRPCONFSCTNMRKCN.SRRPCONF_P);
          /*   -    () */
          NRRPCONF_RD := PKG_RRPCONFSCTNMRKCN.PARAM_GET_NUM_VALUE(NCOMPANY => NCOMPANY,
                                                                  NPRN     => NRRPCONFSCTNMRKCN,
                                                                  SPARAM   => PKG_RRPCONFSCTNMRKCN.SRRPCONF_RD_P);
          /*     */
          if (NRRPCONF_RD = 1) then
            /*     */
            SRRPCONF := UTL_CONF_GET_CODE_BY_CN(NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN);
          end if;
          /*   -   */
          SMARK_CODE := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_CODE_P);
          /*   -   () */
          NMARK_CODE_RD := PKG_RRPCONFSCTNMRKCN.PARAM_GET_NUM_VALUE(NCOMPANY => NCOMPANY,
                                                                    NPRN     => NRRPCONFSCTNMRKCN,
                                                                    SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_CODE_RD_P);
          /*     */
          if (NMARK_CODE_RD = 1) then
            /*     */
            SMARK_CODE := UTL_MARK_GET_CODE_BY_CN(NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN);
          end if;
          /*   -    */
          SMARK_ROW_CODE := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                     NPRN     => NRRPCONFSCTNMRKCN,
                                                                     SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_ROW_CODE_P);
          /*   -    */
          SMARK_COL_CODE := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                     NPRN     => NRRPCONFSCTNMRKCN,
                                                                     SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_COL_CODE_P);
          /*    */
          if (SRRPCONF is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SRRPCONF || ',';
          end if;
          /*     */
          if (SMARK_CODE is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SRRPCONF || ',';
          end if;
          /*     */
          if (SMARK_ROW_CODE is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SMARK_ROW_CODE || ',';
          end if;
          /*     */
          if (SMARK_COL_CODE is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SMARK_COL_CODE || ',';
          end if;
        else
          /*   */
          null;
      end case;
    end MAKE_PRMS_BY_MASK;
    
    /*          */
    function SOURCE_UNIT_GET_PRMS
    (
      NCOMPANY              in number,       -- .  
      NRRPCONFSCTNMRKCN     in number,       -- .     
      SSOURCE_UNIT          in varchar2      --  
    ) return                varchar2         --      
    is
      SRESULT               PKG_STD.TSTRING; --      
    begin
      /*   */
      SRESULT := '(';
      /*      */
      case SSOURCE_UNIT
        /*   */
        when 'EconomicOperations' then
          /*    " "  " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC_DC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   / */
        when 'DebitorsCreditorsAccounts' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*     */
        when 'AccountsRemnants' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*  -  */
        when 'ValuesRemnants' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
        /* /  */
        when 'DebitorsCreditorsRemnants' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        when 'Inventory' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        when 'ItemsCards' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC_WO_ANL);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
        /*     */
        when 'OperCards' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        when 'RRPDocuments' then
          /*     */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_RRPCONF);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*      */
        when 'DeclarationIncome' then
          /*     */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_RRPCONF);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        else
          SRESULT := null;
      end case;
      /*    */
      SRESULT := RTRIM(SRESULT, ',');
      /*   */
      SRESULT := SRESULT || ')';
      /*   */
      return SRESULT;
    end SOURCE_UNIT_GET_PRMS;
    
    /*         */
    function RRPCONFSCTNMRKCN_GET_ST
    (
      NSOURCE_TYPE          in number,       --  
      SSOURCE_UNIT          in varchar2      --  
    ) return                varchar2         --     
    is
      SRESULT               PKG_STD.TSTRING; --     
    begin
      /*     */
      case NSOURCE_TYPE
        when 0 then
          /*    */
          case SSOURCE_UNIT
            when 'EconomicOperations' then
              SRESULT := '';
            when 'DebitorsCreditorsAccounts' then
              SRESULT := '';
            when 'AccountsRemnants' then
              SRESULT := '';
            when 'ValuesRemnants' then
              SRESULT := '';
            when 'DebitorsCreditorsRemnants' then
              SRESULT := '';
            when 'Inventory' then
              SRESULT := '';
            when 'ItemsCards' then
              SRESULT := '';
            when 'OperCards' then
              SRESULT := '';
            when 'DeclarationIncome' then
              SRESULT := '';
            when 'RRPDocuments' then
              SRESULT := '';
            else
              SRESULT := null;
          end case;
        when 1 then
          SRESULT := '';
        when 2 then
          SRESULT := '';
        when 3 then
          SRESULT := '';
        when 4 then
          SRESULT := 'fx';
        else
          SRESULT := null;
      end case;
      /*   */
      return SRESULT;
    end RRPCONFSCTNMRKCN_GET_ST;
    
    /*        */
    function RRPCONFSCTNMRKCN_GET_SIGN
    (
      NSIGN                 in number        --   
    ) return                varchar2         --      
    is
      SRESULT               PKG_STD.TSTRING; --      
    begin
      /*   */
      case NSIGN
        when 0 then
          SRESULT := '+';
        when 1 then
          SRESULT := '-';
        else
          SRESULT := '+/-';
      end case;
      /*   */
      return SRESULT;
    end RRPCONFSCTNMRKCN_GET_SIGN;
  begin
    /*       */
    RREC := GET_RRPCONFSCTNMRKCN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPCONFSCTNMRKCN);
    /*        */
    case RREC.SOURCE_TYPE
      /*   */
      when 0 then
        /*      */
        SCN_DESC := SOURCE_UNIT_GET_PRMS(NCOMPANY          => NCOMPANY,
                                         NRRPCONFSCTNMRKCN => RREC.RN,
                                         SSOURCE_UNIT      => RREC.SOURCE_UNIT);
      /*   */
      when 1 then
        /*     */
        RRRPCONFSCTNMRK := GET_RRPCONFSCTNMRK_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RREC.RRPCONFSCTNMRK);
        /*    */
        SCN_DESC := '(' || RRRPCONFSCTNMRK.CODE || ')';
      /*   */
      when 2 then
        /*      */
        SCN_DESC := '(' || PKG_OBJECT_DESC.STORED_NAME(SPACKAGE_NAME => RREC.PKG, SSTORED_NAME => RREC.PRC) || ')';
      /*   */
      when 3 then
        /*    */
        SCN_DESC := '(' || COALESCE(RREC.STATIC_STR,
                                    COALESCE(TO_CHAR(RREC.STATIC_NUM), TO_CHAR(RREC.STATIC_DATE, 'dd.mm.yyyy'))) || ')';
      /*  */
      when 4 then
        /*   */
        SCN_DESC := '(' || RREC.FORMULA || ')';
      else
        SCN_DESC := null;
    end case;
    /*   */
    SRESULT := RRPCONFSCTNMRKCN_GET_SIGN(NSIGN => RREC.SIGN) || ' ' ||
               RRPCONFSCTNMRKCN_GET_ST(NSOURCE_TYPE => RREC.SOURCE_TYPE, SSOURCE_UNIT => RREC.SOURCE_UNIT) || SCN_DESC;
    /*   */
    return SRESULT;
  end UTL_RRPCONFSCTNMRKCN_GET_DESC;

  /*     */
  procedure RRPCONF_GET_SECTIONS
  (
    NRN_RRPCONF             in number,                             -- .     
    NROW_ORDER              in number := 0,                        --   
    NCOL_ORDER              in number := 0,                        --   
    COUT                    out clob                               --  
  )
  is
    NVERSION                PKG_STD.TREF;                          -- .    
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    RDG                     PKG_P8PANELS_VISUAL.TDG;               --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TDG_ROW;           --  
    CDG                     clob;                                  -- XML  
    CXML                    PKG_CONTVALLOC2NS.TCONTAINER;          --    XML
    RRRPCONFSCTNMRK         RRPCONFSCTNMRK%rowtype;                -- .  
    NCURRENT_SECTION        PKG_STD.TNUMBER;                       --     
    NSECTION_RN             PKG_STD.TREF;                          -- .   
    SSECTION_CODE           PKG_STD.TSTRING;                       --   
    SSECTION_NAME           PKG_STD.TSTRING;                       --   
    CSECTION_CLOB           clob;                                  --    
    CSQL_ROWS               clob;                                  --   
    SORDERS_R               PKG_STD.TSTRING;                       --  
    ICURSOR_R               integer;                               --      
    NROW_RN                 PKG_STD.TREF;                          -- .  
    NROW_POS                PKG_STD.TNUMBER := 0;                  --  
    SROW_CODE               PKG_STD.TSTRING;                       --  
    SROW_NAME               PKG_STD.TSTRING;                       --  
    CSQL_COLS               clob;                                  --   
    SORDERS_C               PKG_STD.TSTRING;                       --  
    ICURSOR_C               integer;                               --      
    NCOL_RN                 PKG_STD.TREF;                          -- .  
    SCOL_CODE               PKG_STD.TSTRING;                       --  
    SCOL_NAME               PKG_STD.TSTRING;                       --  
    
    /*     */
    function ORDER_TEXT_GET
    (
      NORDER                in number,       --  
      SALIAS                in varchar2,     --  
      NTYPE                 in number        --   (0 - , 1 - )
    ) return                varchar2         --   
    is
      SRESULT               PKG_STD.TSTRING; --   
      STABLE_COLUMN_CODE    PKG_STD.TSTRING; --   ,  
    begin
      /*   ,   */
      if (NTYPE = 0) then
        /*   */
        STABLE_COLUMN_CODE := 'COLUMN_CODE';
      else
        /*   */
        STABLE_COLUMN_CODE := 'ROW_CODE';
      end if;
      /*    */
      case NORDER
        /*  -   -  */
        when 1 then
          SRESULT := PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.' || STABLE_COLUMN_CODE || ', 40, ''0''),' || SALIAS ||
                     '.SORT_NUMB,' || PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.CODE, 20, ''0'')';
        /*  -   -  */
        when 2 then
          SRESULT := PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.CODE, 20, ''0''),' || SALIAS || '.SORT_NUMB,' ||
                     PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.' || STABLE_COLUMN_CODE || ', 40, ''0'')';
        /*   -  -  */
        else
          SRESULT := SALIAS || '.SORT_NUMB,' || PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.' || STABLE_COLUMN_CODE ||
                     ', 40, ''0''),' || PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.CODE, 20, ''0'')';
      end case;
      /*   */
      return SRESULT;
    end ORDER_TEXT_GET;
       
    /*     */
    procedure MARKS_COLUMNS_INIT
    (
      RDG                   in out nocopy PKG_P8PANELS_VISUAL.TDG, --  
      NRRPCONFSCTN          in number,                             -- .  
      SORDER                in varchar2                            -- 
    )
    is
      CSQL                  clob;                                  --     
      ICURSOR               integer;                               --        
      SCOL_CODE             PKG_STD.TSTRING;                       --  
      SCOL_NAME             PKG_STD.TSTRING;                       --  
    begin
      /*    */
      CSQL := null;
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select C.CODE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '       C.NAME');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from RRPCONFSCTNMRK T,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '       RRPCOLUMN      C');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where T.PRN = ' || NRRPCONFSCTN);
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '   and T.RRPCOLUMN = C.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' group by C.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          C.CODE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          C.NAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          C.COLUMN_CODE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          C.SORT_NUMB');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' order by ' || SORDER);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*     */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*  .   */
        PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR, IPOSITION => 1, SVALUE => SCOL_CODE);
        /*    */
        PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR, IPOSITION => 2, SVALUE => SCOL_NAME);
        /*   */
        PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                            SNAME      => 'SCOL_' || SCOL_CODE,
                                            SCAPTION   => SCOL_NAME,
                                            SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                            NWIDTH     => 200);
        /* .   */
        PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                            SNAME      => 'NCOL_RN_' || SCOL_CODE,
                                            SCAPTION   => SCOL_NAME || ' . ',
                                            SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                            BVISIBLE   => false);
        /* .   */
        PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                            SNAME      => 'NMARK_RN_' || SCOL_CODE,
                                            SCAPTION   => SCOL_NAME || ' .  ',
                                            SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                            BVISIBLE   => false);
        /*   */
        PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                            SNAME      => 'SMARK_CODE_' || SCOL_CODE,
                                            SCAPTION   => SCOL_NAME || '  ',
                                            SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                            BVISIBLE   => false);
        /*    */
        PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                            SNAME      => 'MARK_CNS_' || SCOL_CODE,
                                            SCAPTION   => SCOL_NAME || '  ',
                                            SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                            BVISIBLE   => false);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end MARKS_COLUMNS_INIT;
    
    /*    / */
    function RRPCONFSCTNMRK_GET_ROWCOL
    (
      NRRPCONFSCTN          in number,              -- .  
      NRRPROW               in number,              -- .  
      NRRPCOLUMN            in number               -- .  
    ) return                RRPCONFSCTNMRK%rowtype  --  
    is
      RRESULT               RRPCONFSCTNMRK%rowtype; -- .  
    begin
      /*  .   */
      begin
        select T.*
          into RRESULT
          from RRPCONFSCTNMRK T
         where T.PRN = NRRPCONFSCTN
           and T.RRPROW = NRRPROW
           and T.RRPCOLUMN = NRRPCOLUMN;
      exception
        when others then
          RRESULT := null;
      end;
      /*   */
      return RRESULT;
    end RRPCONFSCTNMRK_GET_ROWCOL;
  begin
    /*   */
    PKG_CONTVALLOC2NS.PURGE(RCONTAINER => CXML);
    /*    */
    NVERSION := GET_SESSION_VERSION(SUNITCODE => 'RRPConfig');
    /*        */
    for S in (select T.RN NRN,
                     T.VERSION NVERSION,
                     T.CRN NCRN,
                     T.PRN NPRN,
                     T.CODE SCODE,
                     T.NAME SNAME,
                     COALESCE((select 1
                                from RRPCONFSCTNMRK M
                               where M.PRN = T.RN
                                 and ROWNUM = 1),
                              0) NMARKS_EXISTS,
                     ROWNUM RNUM
                from RRPCONFSCTN T
               where T.PRN = NRN_RRPCONF
                 and T.VERSION = NVERSION
               order by T.CODE)
    loop
      /*    */
      RDG := PKG_P8PANELS_VISUAL.TDG_MAKE(BFIXED_HEADER => true, NFIXED_COLUMNS => 1);
      /*   */
      PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                          SNAME      => 'SROW_NAME',
                                          SCAPTION   => '',
                                          SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                          NWIDTH     => 150);
      /*   */
      PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                          SNAME      => 'NROW_POS',
                                          SCAPTION   => ' ',
                                          SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                          BVISIBLE   => false);
      /*   */
      PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                          SNAME      => 'SROW_CODE',
                                          SCAPTION   => ' ',
                                          SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                          BVISIBLE   => false);
      /* .   */
      PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                          SNAME      => 'NROW_RN',
                                          SCAPTION   => '.  ',
                                          SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                          BVISIBLE   => false);
      /*     */
      NROW_POS := 0;
      /*     */
      if (S.NMARKS_EXISTS = 1) then
        /*      */
        SORDERS_C := ORDER_TEXT_GET(NORDER => NCOL_ORDER, SALIAS => 'C', NTYPE => 0);
        /*    */
        MARKS_COLUMNS_INIT(RDG => RDG, NRRPCONFSCTN => S.NRN, SORDER => SORDERS_C);
        begin
          /*      */
          SORDERS_R := ORDER_TEXT_GET(NORDER => NROW_ORDER, SALIAS => 'R', NTYPE => 1);
          /*    */
          CSQL_ROWS := PKG_SQL_BUILD.COMPATIBLE();
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => 'select R.RN,');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '       R.CODE,');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '       R.NAME');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '  from RRPCONFSCTNMRK T,');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '       RRPROW         R');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => ' where T.PRN = ' || S.NRN);
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '   and R.RN = T.RRPROW');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => ' group by R.RN,');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '          R.CODE,');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '          R.NAME,');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '          R.ROW_CODE,');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => '          R.SORT_NUMB');
          PKG_SQL_BUILD.APPEND(SSQL => CSQL_ROWS, SELEMENT1 => ' order by ' || SORDERS_R);
          /*   */
          ICURSOR_R := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
          PKG_SQL_DML.PARSE(ICURSOR => ICURSOR_R, SQUERY => CSQL_ROWS);
          /*     */
          PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR_R, IPOSITION => 1);
          PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR_R, IPOSITION => 2);
          PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR_R, IPOSITION => 3);
          /*   */
          if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR_R) = 0) then
            null;
          end if;
          /*    */
          while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR_R) > 0)
          loop
            /*  .   */
            PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR_R, IPOSITION => 1, NVALUE => NROW_RN);
            /*    */
            PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR_R, IPOSITION => 2, SVALUE => SROW_CODE);
            /*    */
            PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR_R, IPOSITION => 3, SVALUE => SROW_NAME);
            /*    */
            PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                                SNAME  => 'SROW_NAME',
                                                SVALUE => SROW_NAME,
                                                BCLEAR => true);
            /*    */
            PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NROW_POS', NVALUE => NROW_POS);
            /*    */
            PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SROW_CODE', SVALUE => SROW_CODE);
            /*  .   */
            PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NROW_RN', NVALUE => NROW_RN);
            /*    */
            CSQL_COLS := PKG_SQL_BUILD.COMPATIBLE();
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => 'select C.RN,');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '       C.CODE,');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '       C.NAME');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '  from RRPCONFSCTNMRK T,');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '       RRPCOLUMN      C');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => ' where T.PRN = ' || S.NRN);
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '   and C.RN = T.RRPCOLUMN');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => ' group by C.RN,');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '          C.CODE,');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '          C.NAME,');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '          C.COLUMN_CODE,');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => '          C.SORT_NUMB');
            PKG_SQL_BUILD.APPEND(SSQL => CSQL_COLS, SELEMENT1 => ' order by ' || SORDERS_C);
            /*   */
            ICURSOR_C := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
            PKG_SQL_DML.PARSE(ICURSOR => ICURSOR_C, SQUERY => CSQL_COLS);
            /*     */
            PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR_C, IPOSITION => 1);
            PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR_C, IPOSITION => 2);
            PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR_C, IPOSITION => 3);
            /*   */
            if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR_C) = 0) then
              null;
            end if;
            /*    */
            while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR_C) > 0)
            loop
              /*  .   */
              PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR_C, IPOSITION => 1, NVALUE => NCOL_RN);
              /*    */
              PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR_C, IPOSITION => 2, SVALUE => SCOL_CODE);
              /*    */
              PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR_C, IPOSITION => 3, SVALUE => SCOL_NAME);
              /*    / */
              RRRPCONFSCTNMRK := RRPCONFSCTNMRK_GET_ROWCOL(NRRPCONFSCTN => S.NRN,
                                                           NRRPROW      => NROW_RN,
                                                           NRRPCOLUMN   => NCOL_RN);
              /*    */
              PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SCOL_' || SCOL_CODE, SVALUE => SCOL_NAME);
              /*  .   */
              PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCOL_RN_' || SCOL_CODE, NVALUE => NCOL_RN);
              /*  .   */
              PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                                  SNAME  => 'NMARK_RN_' || SCOL_CODE,
                                                  NVALUE => RRRPCONFSCTNMRK.RN);
              /*     */
              if (RRRPCONFSCTNMRK.RN is not null) then
                /*    */
                PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                                    SNAME  => 'SMARK_CODE_' || SCOL_CODE,
                                                    SVALUE => RRRPCONFSCTNMRK.CODE);
                /*     */
                PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'MARK_CNS_' || SCOL_CODE, SVALUE => null);
              end if;
            end loop;
            /*   */
            PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR_C);
            /*     */
            PKG_P8PANELS_VISUAL.TDG_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
            /*     */
            NROW_POS := NROW_POS + 1;
          end loop;
          /*   */
          PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR_R);
        exception
          when others then
            PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR_R);
            PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR_C);
            raise;
        end;
      end if;
      /*   */
      CDG := PKG_P8PANELS_VISUAL.TDG_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
      /*      */
      PKG_CONTVALLOC2NS.PUTN(RCONTAINER => CXML, NTABID => S.RNUM, SROWID => 'RN', NVALUE => S.NRN);
      PKG_CONTVALLOC2NS.PUTS(RCONTAINER => CXML, NTABID => S.RNUM, SROWID => 'CODE', SVALUE => S.SCODE);
      PKG_CONTVALLOC2NS.PUTS(RCONTAINER => CXML, NTABID => S.RNUM, SROWID => 'NAME', SVALUE => S.SNAME);
      PKG_CONTVALLOC2NS.PUTLC(RCONTAINER => CXML, NTABID => S.RNUM, SROWID => 'CLOB', LCVALUE => CDG);
    end loop;
    /*  XML   */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    PKG_XFAST.DOWN_NODE(SNAME => 'DATA');
    /*        */
    for X in 1 .. PKG_CONTVALLOC2NS.COUNT_(RCONTAINER => CXML)
    loop
      /* .  */
      if (X = 1) then
        NCURRENT_SECTION := PKG_CONTVALLOC2NS.FIRST_(RCONTAINER => CXML);
      else
        NCURRENT_SECTION := PKG_CONTVALLOC2NS.NEXT_(RCONTAINER => CXML, NTABID => NCURRENT_SECTION);
      end if;
      /* .   */
      NSECTION_RN := PKG_CONTVALLOC2NS.GETN(RCONTAINER => CXML, NTABID => NCURRENT_SECTION, SROWID => 'RN');
      /*   */
      SSECTION_CODE := PKG_CONTVALLOC2NS.GETS(RCONTAINER => CXML, NTABID => NCURRENT_SECTION, SROWID => 'CODE');
      /*   */
      SSECTION_NAME := PKG_CONTVALLOC2NS.GETS(RCONTAINER => CXML, NTABID => NCURRENT_SECTION, SROWID => 'NAME');
      /* Clob    */
      CSECTION_CLOB := PKG_CONTVALLOC2NS.GETLC(RCONTAINER => CXML, NTABID => NCURRENT_SECTION, SROWID => 'CLOB');
      /*   XML     */
      PKG_XFAST.DOWN_NODE(SNAME => 'SECTIONS');
      PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => NSECTION_RN);
      PKG_XFAST.ATTR(SNAME => 'SCODE', SVALUE => SSECTION_CODE);
      PKG_XFAST.ATTR(SNAME => 'SNAME', SVALUE => SSECTION_NAME);
      PKG_XFAST.ATTR(SNAME  => 'NDELETE_ALLOW',
                     NVALUE => UTL_UNIT_ACTION_GET_ALLOW(SUNIT   => SUNIT_RRPCONFSCTN,
                                                         SACTION => SACTION_DELETE,
                                                         NRN     => NSECTION_RN));
      PKG_XFAST.VALUE_XML(LCVALUE => CSECTION_CLOB);
      /*      */
      PKG_XFAST.DOWN_NODE(SNAME => 'MARK_CNS');
      /*      */
      for REC in (select T.PRN,
                         T.RN,
                         T.NUMB
                    from RRPCONFSCTNMRK   M,
                         RRPCONFSCTNMRKCN T
                   where M.PRN = NSECTION_RN
                     and T.PRN = M.RN
                   order by M.RN,
                            T.NUMB asc)
      loop
        /*   */
        PKG_XFAST.DOWN_NODE(SNAME => 'MARK_CN');
        PKG_XFAST.ATTR(SNAME => 'NPRN', NVALUE => REC.PRN);
        PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => REC.RN);
        PKG_XFAST.ATTR(SNAME => 'SNUMB', SVALUE => REC.NUMB);
        PKG_XFAST.ATTR(SNAME  => 'SDESC',
                       SVALUE => UTL_RRPCONFSCTNMRKCN_GET_DESC(NCOMPANY => NCOMPANY, NRRPCONFSCTNMRKCN => REC.RN));
        PKG_XFAST.UP();
      end loop;
      PKG_XFAST.UP();
      PKG_XFAST.UP();
    end loop;
    PKG_XFAST.UP();
    /*   */
    COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
    PKG_XFAST.EPILOGUE();
    /*   */
    PKG_CONTVALLOC2NS.PURGE(RCONTAINER => CXML);
  end RRPCONF_GET_SECTIONS;

  /*     */
  procedure RRPCONFSCTN_INSERT
  (
    NPRN                    in number,                             -- .     
    SCODE                   in varchar2,                           -- 
    SNAME                   in varchar2,                           -- 
    NRN                     out number                             -- .   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    /*   */
    P_RRPCONFSCTN_INSERT(NCOMPANY            => NCOMPANY,
                         NPRN                => NPRN,
                         SCODE               => SCODE,
                         SNAME               => SNAME,
                         SRRPCONFSCTN        => null,
                         SRRPPRMGRP          => null,
                         SNOTE               => null,
                         NHTML_HIDE          => 0,
                         NHTML_HIDE_NAME_COL => 0,
                         NHTML_MAKE_HIER_GRP => 0,
                         SCLSF_CODE          => null,
                         NLINKS_UPDATE       => 0,
                         NDUP_RN             => null,
                         NRN                 => NRN);
  end RRPCONFSCTN_INSERT;
  
  /*     */
  procedure RRPCONFSCTN_UPDATE
  (
    NRN                     in number,                             -- .  
    SCODE                   in varchar2,                           --  
    SNAME                   in varchar2                            --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RRES                    RRPCONFSCTN%rowtype;                   --      
    RRRPCONFSCTN            RRPCONFSCTN%rowtype;                   --      
    RRRPPRMGRP              RRPPRMGRP%rowtype;                     --     
  begin
    /*    */
    RRES := GET_RRPCONFSCTN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRN);
    /*     */
    if (RRES.RRPCONFSCTN is not null) then
      RRRPCONFSCTN := GET_RRPCONFSCTN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RRES.RRPCONFSCTN);
    end if;
    /*     */
    if (RRES.RRPPRMGRP is not null) then
      RRRPPRMGRP := GET_RRPPRMGRP_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RRES.RRPPRMGRP);
    end if;
    /*   */
    P_RRPCONFSCTN_UPDATE(NRN                 => RRES.RN,
                         NCOMPANY            => NCOMPANY,
                         SCODE               => SCODE,
                         SNAME               => SNAME,
                         SRRPCONFSCTN        => RRRPCONFSCTN.CODE,
                         SRRPPRMGRP          => RRRPPRMGRP.CODE,
                         SNOTE               => RRES.NOTE,
                         NHTML_HIDE          => RRES.HTML_HIDE,
                         NHTML_HIDE_NAME_COL => RRES.HTML_HIDE_NAME_COL,
                         NHTML_MAKE_HIER_GRP => RRES.HTML_MAKE_HIER_GRP,
                         SCLSF_CODE          => RRES.CLSF_CODE,
                         NFORMULA_UPDATE     => 1,
                         NMARK_UPDATE        => 1);
  end RRPCONFSCTN_UPDATE;
  
  /*     */
  procedure RRPCONFSCTN_DELETE
  (
    NRN                     in number                              -- .  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    /*      */
    if (UTL_UNIT_ACTION_GET_ALLOW(SUNIT => SUNIT_RRPCONFSCTN, SACTION => SACTION_DELETE, NRN => NRN) = 0) then
      P_EXCEPTION(0,
                  '     / / .  .');
    end if;
    /*   */
    P_RRPCONFSCTN_DELETE(NRN => NRN, NCOMPANY => NCOMPANY);
  end RRPCONFSCTN_DELETE;
  
  /*   ,      .   */
  procedure RRPCONFSCTNMRK_GET_CODES
  (
    NRN                     in number,    -- .   
    SRRPCONF                out varchar2, --     
    SRRPCONFSCTN            out varchar2, --  
    SRRPCONFSCTNMRK         out varchar2  --   
  )
  is
  begin
    /*   // */
    begin
      select C.CODE,
             S.CODE,
             M.CODE
        into SRRPCONF,
             SRRPCONFSCTN,
             SRRPCONFSCTNMRK
        from RRPCONF        C,
             RRPCONFSCTN    S,
             RRPCONFSCTNMRK M
       where M.RN = NRN
         and S.RN = M.PRN
         and C.RN = S.PRN;
    exception
      when others then
        P_EXCEPTION(0,
                    '     .');
    end;
  end RRPCONFSCTNMRK_GET_CODES;
  
  /*         */
  procedure RRPCONFSCTNMRK_GET_CODE_NAME
  (
    NRRPCONFSCTN            in number,                             -- .  
    NRRPROW                 in number,                             -- .  
    NRRPCOLUMN              in number,                             -- .  
    SCODE                   out varchar2,                          --   
    SNAME                   out varchar2                           --       
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RRRPCONFSCTN            RRPCONFSCTN%rowtype;                   --    
    RRRPROW                 RRPROW%rowtype;                        --    
    RRRPCOLUMN              RRPCOLUMN%rowtype;                     --    
  begin
    /*      */
    RRRPCONFSCTN := GET_RRPCONFSCTN_ID(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, NRN => NRRPCONFSCTN);
    /*      */
    RRRPROW := GET_RRPROW_ID(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, NRN => NRRPROW);
    /*      */
    RRRPCOLUMN := GET_RRPCOLUMN_ID(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, NRN => NRRPCOLUMN);
    /*     */
    if ((RRRPCONFSCTN.RN is not null) and (RRRPROW.RN is not null) and (RRRPCOLUMN.RN is not null)) then
      /*    */
      P_RRPCONFSCTNMRK_MAKE_CODE(SRRPCONFSCTN => RRRPCONFSCTN.CODE,
                                 SRRPROW      => RRRPROW.CODE,
                                 SRRPCOLUMN   => RRRPCOLUMN.CODE,
                                 SCODE        => SCODE);
      /*    */
      P_RRPCONFSCTNMRK_MAKE_NAME(NCOMPANY            => NCOMPANY,
                                 NRRPROW             => RRRPROW.RN,
                                 NRRPCOLUMN          => RRRPCOLUMN.RN,
                                 NCHANGE_NAME        => 1,
                                 NCHANGE_NAME_PARENT => 0,
                                 SNAME               => SNAME);
    end if;
  end RRPCONFSCTNMRK_GET_CODE_NAME;
  
  /*         */
  procedure RRPCONFSCTNMRK_GET_NAME
  (
    NRRPCONFSCTNMRK         in number,                             -- .  
    SNAME                   out varchar2                           --       
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RRRPCONFSCTNMRK         RRPCONFSCTNMRK%rowtype;                --    
  begin
    /*      */
    RRRPCONFSCTNMRK := GET_RRPCONFSCTNMRK_ID(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, NRN => NRRPCONFSCTNMRK);
    /*    */
    SNAME := RRRPCONFSCTNMRK.NAME;
  end RRPCONFSCTNMRK_GET_NAME;
  
  /*      */
  procedure RRPCONFSCTNMRK_INSERT
  (
    NPRN                    in number,                             -- .  
    SCODE                   in varchar2,                           --   
    SNAME                   in varchar2,                           --   
    NRRPROW                 in number,                             -- .  
    NRRPCOLUMN              in number,                             -- .  
    NRN                     out number                             -- .   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RRRPROW                 RRPROW%rowtype;                        --    
    RRRPVERSION_ROW         RRPVERSION%rowtype;                    --     
    RRRPCOLUMN              RRPCOLUMN%rowtype;                     --    
    RRRPVERSION_COL         RRPVERSION%rowtype;                    --     
  begin
    /*     */
    if (NRRPROW is null) then
      P_EXCEPTION(0,
                  '    .');
    end if;
    /*     */
    if (NRRPCOLUMN is null) then
      P_EXCEPTION(0,
                  '    .');
    end if;
    /*      */
    RRRPROW := GET_RRPROW_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPROW);
    /*      */
    RRRPCOLUMN := GET_RRPCOLUMN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPCOLUMN);
    /*       */
    RRRPVERSION_ROW := GET_RRPVERSION_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RRRPROW.RRPVERSION);
    /*       */
    RRRPVERSION_COL := GET_RRPVERSION_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RRRPCOLUMN.RRPVERSION);
    /*   */
    P_RRPCONFSCTNMRK_INSERT(NCOMPANY           => NCOMPANY,
                            NPRN               => NPRN,
                            NNUMB              => F_RRPCONFSCTNMRK_NEXT_NUMB(NCOMPANY => NCOMPANY, NPRN => NPRN),
                            SCODE              => SCODE,
                            SNAME              => SNAME,
                            SRRPROW            => RRRPROW.CODE,
                            SRRPVERSION_ROW    => RRRPVERSION_ROW.CODE,
                            SRRPCOLUMN         => RRRPCOLUMN.CODE,
                            SRRPVERSION_COLUMN => RRRPVERSION_COL.CODE,
                            SPKG_ROW           => null,
                            SPRC_ROW           => null,
                            SPKG_COL           => null,
                            SPRC_COL           => null,
                            SRRPPRM            => null,
                            NIGNORE_ZOOM       => 0,
                            NIGNORE_SHARP      => 0,
                            SCLSF_CODE         => null,
                            SNOTE              => null,
                            NDUP_RN            => null,
                            NRN                => NRN);
  end RRPCONFSCTNMRK_INSERT;
  
  /*      */
  procedure RRPCONFSCTNMRK_UPDATE
  (
    NRN                     in number,                             -- .               
    SNAME                   in varchar2                            --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RESSCTNMRK              RRPCONFSCTNMRK%rowtype;                --     
    RESROW                  RRPROW%rowtype;                        --    
    RESCOLUMN               RRPCOLUMN%rowtype;                     --    
    RRRPPRM                 RRPPRM%rowtype;                        --     
    SROWVER                 PKG_STD.TSTRING;                       --   
    SCOLVER                 PKG_STD.TSTRING;                       --   
  begin
    /*     */
    RESSCTNMRK := GET_RRPCONFSCTNMRK_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRN);
    /*    */
    RESROW := GET_RRPROW_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RESSCTNMRK.RRPROW);
    /*    */
    RESCOLUMN := GET_RRPCOLUMN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RESSCTNMRK.RRPCOLUMN);
    /*     */
    if (RESROW.RRPVERSION is not null) then
      SROWVER := GET_RRPVERSION_CODE_ID(NFLAG_SMART => 0, NRN => RESROW.RRPVERSION);
    end if;
    /*     */
    if (RESCOLUMN.RRPVERSION is not null) then
      SCOLVER := GET_RRPVERSION_CODE_ID(NFLAG_SMART => 0, NRN => RESCOLUMN.RRPVERSION);
    end if;
    /*     */
    if (RESSCTNMRK.RRPPRM is not null) then
      RRRPPRM := GET_RRPPRM_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RESSCTNMRK.RRPPRM);
    end if;
    /*   */
    P_RRPCONFSCTNMRK_UPDATE(NRN                => NRN,
                            NCOMPANY           => NCOMPANY,
                            NNUMB              => RESSCTNMRK.NUMB,
                            SCODE              => RESSCTNMRK.CODE,
                            SNAME              => SNAME,
                            SRRPROW            => RESROW.CODE,
                            SRRPVERSION_ROW    => SROWVER,
                            SRRPCOLUMN         => RESCOLUMN.CODE,
                            SRRPVERSION_COLUMN => SCOLVER,
                            SPKG_ROW           => RESSCTNMRK.PKG_ROW,
                            SPRC_ROW           => RESSCTNMRK.PRC_ROW,
                            SPKG_COL           => RESSCTNMRK.PKG_COL,
                            SPRC_COL           => RESSCTNMRK.PRC_COL,
                            SRRPPRM            => RRRPPRM.CODE,
                            NIGNORE_ZOOM       => RESSCTNMRK.IGNORE_ZOOM,
                            NIGNORE_SHARP      => RESSCTNMRK.IGNORE_SHARP,
                            SCLSF_CODE         => RESSCTNMRK.CLSF_CODE,
                            NFORMULA_UPDATE    => 0,
                            SNOTE              => RESSCTNMRK.NOTE);
  end RRPCONFSCTNMRK_UPDATE;
  
  /*      */
  procedure RRPCONFSCTNMRK_DELETE
  (        
    NRN                     in number                              -- .   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    /*      */
    if (UTL_UNIT_ACTION_GET_ALLOW(SUNIT => SUNIT_RRPCONFSCTNMRK, SACTION => SACTION_DELETE, NRN => NRN) = 0) then
      P_EXCEPTION(0,
                  '     .  .');
    end if;
    /*   */
    P_RRPCONFSCTNMRK_DELETE(NCOMPANY => NCOMPANY, NRN => NRN);
  end RRPCONFSCTNMRK_DELETE;
  
end PKG_P8PANELS_RRPCONFED;
/
